about summary refs log tree commit diff stats
diff options
context:
space:
mode:
authorBenedikt Peetz <benedikt.peetz@b-peetz.de>2025-04-27 16:43:37 +0200
committerBenedikt Peetz <benedikt.peetz@b-peetz.de>2025-04-27 16:43:37 +0200
commite66fea3fb8b4d283a06be2ad46ec6a0ec64cce43 (patch)
treedf499d89fc76c388ecd02bc354454960c3e3556f
parentnotes/wifi.md: Add (diff)
downloadnixos-config-e66fea3fb8b4d283a06be2ad46ec6a0ec64cce43.zip
pkgs/fd_list: Init
-rwxr-xr-xpkgs/by-name/fd/fd_list/fd_list.sh40
-rw-r--r--pkgs/by-name/fd/fd_list/package.nix28
2 files changed, 68 insertions, 0 deletions
diff --git a/pkgs/by-name/fd/fd_list/fd_list.sh b/pkgs/by-name/fd/fd_list/fd_list.sh
new file mode 100755
index 00000000..568d73c8
--- /dev/null
+++ b/pkgs/by-name/fd/fd_list/fd_list.sh
@@ -0,0 +1,40 @@
+#!/usr/bin/env bash
+
+# nixos-config - My current NixOS configuration
+#
+# Copyright (C) 2025 Benedikt Peetz <benedikt.peetz@b-peetz.de>
+# SPDX-License-Identifier: GPL-3.0-or-later
+#
+# This file is part of my nixos-config.
+#
+# You should have received a copy of the License along with this program.
+# If not, see <https://www.gnu.org/licenses/gpl-3.0.txt>.
+
+# Lists all fds in use with their respective associated programs.
+# This can be useful, if you need to debug, why your system is out of fds.
+
+# This script is not POSIX shell compatible, as the `ulimit` flags `-H` and `-n` are not defined by POSIX (thus we use `bash` instead).
+
+find /proc/ -maxdepth 1 | while read -r path; do
+    pid="${path#/proc/}"
+    fd_dir="$path/fd/"
+
+    [ -d "$fd_dir" ] && echo "PID = $pid with $(find "$fd_dir" | wc -l) file descriptors"
+done | sort -rn -k5 | head | while read -r _ _ pid _ fdcount _; do
+    command_execution="$(ps -o cmd -p "$pid" -h)"
+
+    command_arguments="$(echo "$command_execution" | awk '{$1=""; print $0}')"
+    command_name="$(basename "$(echo "$command_execution" | awk '{print $1}')")"
+
+    command="$command_name$command_arguments"
+
+    printf "PID %8d with %4d file descriptors: %s\n" "$pid" "$fdcount" "$command"
+done || true
+# ^ Ignore SIGPIPE
+
+printf "\nThe Kernel has %7d file handles allocated.\n" "$(awk '{print $1}' /proc/sys/fs/file-nr)"
+printf "    -> The per-process fd maxium is: %d\n" "$(ulimit -Hn)"
+printf "    -> The per-process fd soft-maximum is: %d\n" "$(ulimit -n)"
+printf "    -> The global fd maximum is: %d\n" "$(cat /proc/sys/fs/file-max)"
+
+# vim: ft=sh
diff --git a/pkgs/by-name/fd/fd_list/package.nix b/pkgs/by-name/fd/fd_list/package.nix
new file mode 100644
index 00000000..34129b10
--- /dev/null
+++ b/pkgs/by-name/fd/fd_list/package.nix
@@ -0,0 +1,28 @@
+# nixos-config - My current NixOS configuration
+#
+# Copyright (C) 2025 Benedikt Peetz <benedikt.peetz@b-peetz.de>
+# SPDX-License-Identifier: GPL-3.0-or-later
+#
+# This file is part of my nixos-config.
+#
+# You should have received a copy of the License along with this program.
+# If not, see <https://www.gnu.org/licenses/gpl-3.0.txt>.
+{
+  writeShellApplication,
+  findutils,
+  gawk,
+  coreutils,
+  procps,
+}:
+writeShellApplication {
+  name = "fd_list";
+  text = builtins.readFile ./fd_list.sh;
+
+  inheritPath = false;
+  runtimeInputs = [
+    findutils
+    gawk
+    coreutils
+    procps
+  ];
+}